rand('seed', getdate('s'))
rand('uniform')

function y=simul_binomiale(N,p)
  y=0
  for k=1:N
    if (rand()<p) then y=y+1
    end
  end
endfunction

function y=loi_binomiale(n,p)
    y=zeros(1,n+1)
    // ci-dessous on met à jour le vecteur y pour que y(1,k) contienne P(X=k-1) pour 1<=k<=n+1
    y(1)=(1-p)^n
    for k=1:n
        // P(X=k)=(n-k+1)/k*p/(1-p)*P(X=k-1)
        y(k+1)=(n-k+1)/k*p/(1-p)*y(k)
    end
endfunction

n=100 
N0=20
p0=.25
S=zeros(1,n)
for k=1:n
  S(k)=simul_binomiale(N0,p0)
end
[I,dstat]=dsearch(S,0:N0,'d')
dstat=dstat/n
loi=loi_binomiale(N0,p0)
clf
bar(0:N0,[dstat;loi]')
