rand('seed', getdate('s'))
rand('uniform')

function Y=simul_poisson(n,lambda)
  // simule n variables aléatoires indépendantes de Poisson
  Y=-ones(1,n)
  k=0
  e=exp(-lambda)
  p=e
  F=p
  U=rand(1,n)
  while (length(find(Y==-1))>0)
      Y(find((Y==-1)&(U<=F)))=k
      k=k+1
      p=p*lambda/k
      F=F+p     // calcul de F_k
  end
endfunction

function y=loi_poisson(N,lambda)
    y=exp(-lambda)*lambda.^(0:N)./[1,cumprod(1:N)]
endfunction

n0=1000   // nombre de simulations
N0=20   // abscisse maximale pour le diagramme
lambda0=5  // choix du paramètre
S=simul_poisson(n0,lambda0)
[I,dstat]=dsearch(S,0:N0,'d')
dstat=dstat/n0
loi=loi_poisson(N0,lambda0)
clf
bar(0:N0,[dstat;loi]')
